%
% inicijalizacija.m
%
% Inicijalizacija servera, reset MatLab-ovog opc modula i
% azuriranje ulaznih vrijednosti u matlab modelu...
%
% by Samir & Lejla & Lejla & Adis, ujutro & popodne (Grupa 7), 1.6.2005.
%

opcreset
clear mpcopcPlantStep
clear mpcopcMPCStep
 try
    Server = opcda('localhost','Studio.Scada.OPC');
    connect(Server);
 catch
    error('Server nije aktivan!')
 end

%
% kupljenje svih item-a prisutnih na serveru...
% serveritems(Server)
%

%
% kreiranje grupa i "OPC Item" objekata...
%

Citanje = addgroup(Server,'Citanje');
 PojacanjeRegulatora = additem(Citanje,'iUlazKr');
 IntegralnoVrijeme = additem(Citanje,'iUlazTi');
 DerivativnoVrijeme = additem(Citanje,'iUlazTd');
 ZadanaVrijednost = additem(Citanje,'iInicijalizacijaZadanaVrijednost');
 %Kob
  Pojacanje = additem(Citanje,'iInicijalizacijaKob');
 %Tob
  VremenskaKonstanta = additem(Citanje,'iInicijalizacijaTob');
 %ksi
  FaktorPrigusenja = additem(Citanje,'iInicijalizacijaKsi');
 %tau
  IznosCistogKasnjenja = additem(Citanje,'iInicijalizacijaTau');

KontrolaMatlab = addgroup(Server,'KontrolaMatlab');
 MatlabPokrenut = additem(KontrolaMatlab, 'kMatPokrenut');

KontrolaSimulacija = addgroup(Server,'KontrolaSimulacija');
 ModelAktivan = additem(KontrolaSimulacija,'kModelAktivan');

KontrolaRjesavanje = addgroup(Server,'KontrolaRjesavanje');
 TraziRjesenje = additem(KontrolaRjesavanje,'kRjesavanje');

KontrolaPodesavanje = addgroup(Server,'KontrolaPodesavanje');
 Podesavanje = additem(KontrolaPodesavanje,'kPodesenje');

Pisanje = addgroup(Server,'Pisanje');
 PrenosnaFunkcija = additem(Pisanje,'iIzlazIzlaz');
 TrenutniPeriod = additem (Pisanje, 'iIzlazPeriod');
 TrenutniFaktorPrigusenja = additem (Pisanje, 'iIzlazFaktorPrigusenja');

Klase = addgroup(Server,'Klase');
 UlazKr0 = additem(Klase,'iUlazEksperiment[0].iUlazKr');
  set(UlazKr0,'DataType','double');
 UlazKr1 = additem(Klase,'iUlazEksperiment[1].iUlazKr');
  set(UlazKr1,'DataType','double');
 UlazKr2 = additem(Klase,'iUlazEksperiment[2].iUlazKr');
  set(UlazKr2,'DataType','double');
 UlazTi0 = additem(Klase,'iUlazEksperiment[0].iUlazTi');
  set(UlazTi0,'DataType','double');
 UlazTi1 = additem(Klase,'iUlazEksperiment[1].iUlazTi');
  set(UlazTi1,'DataType','double');
 UlazTi2 = additem(Klase,'iUlazEksperiment[2].iUlazTi');
  set(UlazTi2,'DataType','double');
 UlazTd0 = additem(Klase,'iUlazEksperiment[0].iUlazTd');
  set(UlazTd0,'DataType','double');
 UlazTd1 = additem(Klase,'iUlazEksperiment[1].iUlazTd');
  set(UlazTd1,'DataType','double');
 UlazTd2 = additem(Klase,'iUlazEksperiment[2].iUlazTd');
  set(UlazTd2,'DataType','double');
 IzlazPeriod0 = additem(Klase,'iUlazEksperiment[0].iIzlazPeriod');
  set(IzlazPeriod0,'DataType','double');
 IzlazPeriod1 = additem(Klase,'iUlazEksperiment[1].iIzlazPeriod');
  set(IzlazPeriod1,'DataType','double');
 IzlazPeriod2 = additem(Klase,'iUlazEksperiment[2].iIzlazPeriod');
  set(IzlazPeriod2,'DataType','double');

KlasaIdentifikacija = addgroup(Server,'KlasaIdentifikacija');
 InicijalizacijaKob = additem (KlasaIdentifikacija,'iIdentificiraniParametriObjekta.iInicijalizacijaKob');
  set(InicijalizacijaKob,'DataType','double');
 InicijalizacijaTob = additem (KlasaIdentifikacija,'iIdentificiraniParametriObjekta.iInicijalizacijaTob');
  set(InicijalizacijaTob,'DataType','double');
 InicijalizacijaKsi = additem (KlasaIdentifikacija,'iIdentificiraniParametriObjekta.iInicijalizacijaKsi');
  set(InicijalizacijaKsi,'DataType','double');
 InicijalizacijaTau = additem (KlasaIdentifikacija,'iIdentificiraniParametriObjekta.iInicijalizacijaTau');
  set(InicijalizacijaTau,'DataType','double');

KlasaParametriPodesenja = addgroup(Server,'ParametriPodesenja');
 UlazKr3 = additem (KlasaParametriPodesenja,'iParametriPodesenja.iUlazKr');
  set(UlazKr3,'DataType','double');
 IzlazPeriod3 = additem (KlasaParametriPodesenja,'iParametriPodesenja.iIzlazPeriod');
  set(IzlazPeriod3,'DataType','double');

KlasaPodesenje = addgroup(Server,'KlasaPodesenje');
 UlazKr4 = additem (KlasaPodesenje,'iPodesenjeRegulatora.iUlazKr');
  set(UlazKr4,'DataType','double');
 UlazTi4 = additem (KlasaPodesenje,'iPodesenjeRegulatora.iUlazTi');
  set(UlazTi4,'DataType','double');
 UlazTd4 = additem (KlasaPodesenje,'iPodesenjeRegulatora.iUlazTd');
  set(UlazTd4,'DataType','double');

%
% dodjeljivanje tipa & default vrijednosti OPC Item varijablama...
%

set(PojacanjeRegulatora,'DataType','double');
 write(PojacanjeRegulatora, 1.36);
set(IntegralnoVrijeme,'DataType','double');
 write(IntegralnoVrijeme, 10);
set(DerivativnoVrijeme,'DataType','double');
 write(DerivativnoVrijeme, 0.55);

set(ZadanaVrijednost,'DataType','double');
 write(ZadanaVrijednost, 1);
set(Pojacanje,'DataType','double');
 write(Pojacanje, 2);
set(VremenskaKonstanta,'DataType','double');
 write(VremenskaKonstanta, 1);
set(FaktorPrigusenja,'DataType','double');
 write(FaktorPrigusenja, 1.5);
set(IznosCistogKasnjenja,'DataType','double');
 write(IznosCistogKasnjenja, 2);

set(PrenosnaFunkcija,'DataType','double');
set(TrenutniPeriod,'DataType','double');
set(TrenutniFaktorPrigusenja,'DataType','double');

set(MatlabPokrenut, 'DataType', 'logical');
set(ModelAktivan, 'DataType','logical');
set(TraziRjesenje, 'DataType', 'logical');
set(Podesavanje, 'DataType', 'logical');

%
% pokretanje m fajlova u MatLabu Event-om sa OPC servera:
%

Citanje.DataChangeFcn = 'azuriraj_ulaze'
KontrolaMatlab.DataChangeFcn = 'kontrolaMatlab'
KontrolaSimulacija.DataChangeFcn = 'kontrolaSimulacija'
KontrolaRjesavanje.DataChangeFcn = 'kontrolaRjesavanja'
KontrolaPodesavanje.DataChangeFcn = 'kontrolaPodesenje'

% Neke globalne varijable:
trajanjeSimulacije = 1000

write(MatlabPokrenut, 1);
