%
% period.m
%
% Proracun perioda oscilacije trenutne simulacije...
%
% by Zeljko, 1.6.2005.
%

function [PeriodOscilovanja, FaktorPrigusenja] = period(vrijeme,izlaz);

n=size(izlaz);
stacionarna=mean(izlaz);

presjeci=[]; vrhovi=[]; razmjere=[];

for i=1:n-1,
   if (izlaz(i)-stacionarna)*(izlaz(i+1)-stacionarna)<=0,
      presjeci=[presjeci,(vrijeme(i)+vrijeme(i+1))/2];
   end;
   if i>1 & (izlaz(i-1)<izlaz(i)) & (izlaz(i)>izlaz(i+1)),
      vrhovi=[vrhovi,izlaz(i)-stacionarna];
   end   
end;

poluperiodi=diff(presjeci);

for i=1:length(vrhovi)-1,
   razmjere=[razmjere,vrhovi(i+1)/vrhovi(i)];
end;

PeriodOscilovanja=2*mean(poluperiodi);
FaktorPrigusenja=-log(mean(razmjere))/PeriodOscilovanja;

