%
% podesenje.m
%
% Proracunavanje parametara za dobro podesenje regulatora metodom Ziegler-Nichols-a...
%
% by Lejla, Lejla, Samir, Adis, 4.6.2005.
%

function [Kr, Ti, Td] = podesenje(podaci);

  Kr1=podaci(1,1);
  T=podaci(1,2);

  Kr = 0.6*Kr1;
  Ti = 0.5*T;
  Td = 0.125*T;

  % Ako nije pogodno da parametar Td ima vrijednost vecu od 0 (u slucaju da objekat
  % ima puno smetnji, sto nije slucaj za testirani objekat), parametre regulatora
  % treba postaviti na sljedece vrijednosti:
  %
  % Kr = 0.4*Kr1;
  % Ti = 0.8*T;
  % Td = 0;