%
% proracun.m
%
% Proracunavanje rezultatskih parametara iz tri eksperimenta...
%
% by Zeljko, 1.6.2005.
%

function [Kob, Tob, Ksi, Tau] = proracun(podaci);

Kr1=podaci(1,1); Ti1=podaci(1,2); Td1=podaci(1,3); w1=2*pi/podaci(1,4);
Kr2=podaci(2,1); Ti2=podaci(2,2); Td2=podaci(2,3); w2=2*pi/podaci(2,4);
Kr3=podaci(3,1); Ti3=podaci(3,2); Td3=podaci(3,3); w3=2*pi/podaci(3,4);

matrica=[Kr1^2*(1+(Td1*w1-1/(Ti1*w1))^2),-2*w1^2,-w1^4;
   Kr2^2*(1+(Td2*w2-1/(Ti2*w2))^2),-2*w2^2,-w2^4;
   Kr3^2*(1+(Td3*w3-1/(Ti3*w3))^2),-2*w3^2,-w3^4];

rjesenja=matrica\[1;1;1];

alfa=rjesenja(1); beta=rjesenja(2); gama=rjesenja(3);

Kob=sqrt(alfa);
Tob=sqrt(sqrt(gama));
Ksi=sqrt((1+beta/Tob^2)/2);

j=sqrt(-1);
tau1=(pi+angle((1+1/(Ti1*j*w1)+Td1*j*w1)/(2*Tob*Ksi*j*w1+1-Tob^2*w1^2)))/w1;
tau2=(pi+angle((1+1/(Ti2*j*w2)+Td2*j*w2)/(2*Tob*Ksi*j*w2+1-Tob^2*w2^2)))/w2;
tau3=(pi+angle((1+1/(Ti3*j*w3)+Td3*j*w3)/(2*Tob*Ksi*j*w3+1-Tob^2*w3^2)))/w3;
Tau=mean([tau1,tau2,tau3]);